﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Private Sql1 As SQL
	Private DBFileName As String
	Private crMoney As Cursor
	Private Run As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(DataBaseFile As String)
	Try
		DBFileName = DataBaseFile            'Nombre del archivo que contiene la base de datos
	
		If (File.ExternalWritable)Then
			' Se supone que si la base de datos Existe, no se debe sobreescribir.
			' pero los datos se deben de guardar sin saltos. Por eso se inicia con un archivo vacio
			'If Not (File.Exists(File.DirDefaultExternal, DBFileName)) Then				
				File.Copy(File.DirAssets, DBFileName, File.DirDefaultExternal, DBFileName)
			'End If
		
			
			Sql1.Initialize(File.DirDefaultExternal, DBFileName, True)
		
			Run = True      'Base de datos Corriendo
		Else
			Run = False     'No se pudo crear base datos. Base de datos no usable
		End If
	Catch
		Log(LastException)
	End Try
End Sub

public Sub Insert(MarketName As String, Buy As Double, Sell As Double) As Long
	Dim Query As String
	Dim time As Long
	
	time = 0
	
	Try
		'Si los datos son '0' no se guardan
		If (Buy > 0) And (Sell > 0) Then
			time = DateTime.Now
			Query = "INSERT INTO `money`(`id`,`MarketName`,`buy`,`sell`,`time`) VALUES (NULL," & "'" & MarketName & "'" & "," & Buy & "," & Sell & "," & time & ");"
			Log(Query)
			Sql1.ExecNonQuery(Query)			
		End If
	Catch
		Log(LastException)
	End Try
	
	Return time
End Sub

'TRUE si a una hora dada se guardo un dato
Public Sub ExisteDato(time As Long) As Boolean
	Dim Query As String
	Dim Respuesta As Long
	
	Query = "SELECT * FROM money WHERE time = " & time
	
	crMoney = Sql1.ExecQuery(Query)
	For i = 0 To crMoney.RowCount - 1
		crMoney.Position = i
		'		Log("m:" & crMoney.GetString("MarketName"))
		'		Log("b:" & crMoney.GetString("buy"))
		'		Log("s:" & crMoney.GetInt("sell"))
		Respuesta = crMoney.GetInt("time")
	Next
	
	If Respuesta == time Then
		Return True
	Else
		Return False
	End If
End Sub

'Para saber cuantos registros se han guardado
Public Sub Count
	Dim Query As String
	Query = "SELECT COUNT (*) FROM money"
	
	Main.Registros = Sql1.ExecQuerySingleResult(Query)
End Sub

'Informa si la base de datos esta funcionando 
Public Sub GetRun As Boolean
	Return Run
End Sub