﻿Type=StaticCode
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

' No se si hay una forma mejor de hacer esto. Cree una variable ApiSecret en Main -> Globals Pero no se ve por
' las funciones que requieren el dato. Por eso toco hacerlo de esta forma
Public Sub GetApiSecret() As String
	Dim Secret As String
	
	Secret = "f6b846033eb54497b3eaf6d72aec185f"     'Solo para desarrollo
	
	Return Secret
End Sub

'funcion para firmar la url y poder recibir datos de Bittrex
Sub HashHmac(data As String, secret As String) As Byte()
	Try
		Dim m As Mac                                'm As Message Authentication Code
		Dim kg As KeyGenerator                      'kg As KeyGenerator
		kg.Initialize("HmacSHA512")                 'initialize kg using HmacSHA512 algorithm
		kg.KeyFromBytes(secret.GetBytes("UTF8"))    'encode string "secret" to an array of Bytes using UTF8
		m.Initialise("HmacSHA512", kg.Key)          'initialize m using HmacSHA512 algorithm and the secret key
		m.Update(data.GetBytes("UTF8"))             'encodes post data to an array of Bytes and loads it to be signed
		Return m.Sign
	Catch
		ToastMessageShow("Money.HashHmac"&LastException, True)
	End Try
End Sub

'Funcion para preprocesar los datos recibidos.
'A veces son numeros, a veces cadenas. Lo cual produce quiebres de la aplicacion
Sub Str2double(strValue As String) As Double
	Try
		'Si no se recibe nada retorna un '0'
		If (strValue == "") Then
			strValue = "0"
		End If
	
		'Si se recibe una cadena "null" retorna un '0'
		If (strValue.Contains("null")) Then
			strValue = "0"
		End If
	
		'El valor contenido en strValue se convierte a Double
		Dim doubleValue As Double = strValue
	Catch
		Log(LastException)
		ToastMessageShow ("function.str2double " & LastException, True)
	End Try
	
	'Retornamos el valor
	Return doubleValue
End Sub